unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, psapi;

type
  TDialog = class(TForm)
    ListBox: TListBox;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    procedure PrintMemoryInfo(processID: DWORD);
  public
    { Public declarations }
  end;

var
  Dialog: TDialog;

implementation

{$R *.dfm}

procedure TDialog.PrintMemoryInfo(processID: DWORD);
    var
      hProcess: THandle;
      pmc: PROCESS_MEMORY_COUNTERS;
      //total: DWORD;

    begin

      // Print the process identifier.
     listbox.Items.Add(format('Process ID: %d', [processID]));

      // Print information about the memory usage of the process.
      hProcess := OpenProcess(PROCESS_QUERY_INFORMATION or PROCESS_VM_READ, FALSE,
        processID);

      if (hProcess = 0) then
      begin
        exit;
      end;

      if (GetProcessMemoryInfo(hProcess, @pmc, SizeOf(pmc))) then
      begin
        listbox.items.add(format(#09'PageFaultCount: 0x%.8X', [pmc.PageFaultCount]));
        listbox.items.add(format(#09'PeakWorkingSetSize: 0x%.8X', [pmc.PeakWorkingSetSize]));
        listbox.items.add(format(#09'WorkingSetSize: 0x%.8X', [pmc.WorkingSetSize]));
        listbox.items.add(format(#09'QuotaPeakPagedPoolUsage: 0x%.8X',
          [pmc.QuotaPeakPagedPoolUsage]));
        listbox.items.add(format(#09'QuotaPagedPoolUsage: 0x%.8X',
          [pmc.QuotaPagedPoolUsage]));
        listbox.items.add(format(#09'QuotaPeakNonPagedPoolUsage: 0x%.8X',
          [pmc.QuotaPeakNonPagedPoolUsage]));
        listbox.items.add(format(#09'QuotaNonPagedPoolUsage: 0x%.8X',
          [pmc.QuotaNonPagedPoolUsage]));
        listbox.items.add(format(#09'PagefileUsage: 0x%.8X', [pmc.PagefileUsage]));
        listbox.items.add(format(#09'PeakPagefileUsage: 0x%.8X', [pmc.PeakPagefileUsage]));
        listbox.items.add(format(#09'PagefileUsage: 0x%.8X', [pmc.PagefileUsage]));

      end;

      CloseHandle(hProcess);
end;

procedure TDialog.FormCreate(Sender: TObject);
var
      aProcesses: array [0 .. 1024] of DWORD;
      cbNeeded, cProcesses: cardinal;//DWORD;
      i: Integer;

    begin
      try
        // Get the list of process identifiers.
        if (not EnumProcesses(@aProcesses, SizeOf(aProcesses), cbNeeded)) then
          halt(1);

        // Calculate how many process identifiers were returned.
        cProcesses := cbNeeded div SizeOf(DWORD); 

        // Print the memory usage for each process
        for i := 0 to cProcesses - 1 do
        begin
          PrintMemoryInfo(aProcesses[i]);
        end;
      except
        on E: Exception do
          listbox.items.add(E.ClassName+ ': '+ E.Message);
      end;

end;

end.
